Index: /TOOLS/MOSAIX/nemo.py
===================================================================
--- /TOOLS/MOSAIX/nemo.py	(revision 6665)
+++ /TOOLS/MOSAIX/nemo.py	(revision 6666)
@@ -1207,48 +1796,48 @@
         gsin = gsin.assign_coords ( glam.coords )
         gcos = gcos.assign_coords ( glam.coords )
-        
+
     return gsin, gcos
 
 def rot_en2ij ( u_e, v_n, gsin, gcos, nperio, cd_type ) :
-    '''
-    ** Purpose :   Rotate the Repere: Change vector componantes between
+    '''Rotates the Repere: Change vector componantes between
     geographic grid --> stretched coordinates grid.
-    All components are on the same grid (T, U, V or F) 
+
+    All components are on the same grid (T, U, V or F)
     '''
 
     u_i = + u_e * gcos + v_n * gsin
     v_j = - u_e * gsin + v_n * gcos
-    
+
     u_i = lbc (u_i, nperio=nperio, cd_type=cd_type, psgn=-1.0)
     v_j = lbc (v_j, nperio=nperio, cd_type=cd_type, psgn=-1.0)
-    
+
     return u_i, v_j
 
 def rot_ij2en ( u_i, v_j, gsin, gcos, nperio, cd_type='T' ) :
-    '''
-    ** Purpose :   Rotate the Repere: Change vector componantes from
+    '''Rotates the Repere: Change vector componantes from
     stretched coordinates grid --> geographic grid
-    All components are on the same grid (T, U, V or F) 
+
+    All components are on the same grid (T, U, V or F)
     '''
     u_e = + u_i * gcos - v_j * gsin
     v_n = + u_i * gsin + v_j * gcos
+
+    u_e = lbc (u_e, nperio=nperio, cd_type=cd_type, psgn=1.0)
+    v_n = lbc (v_n, nperio=nperio, cd_type=cd_type, psgn=1.0)
+
+    return u_e, v_n
+
+def rot_uv2en ( uo, vo, gsint, gcost, nperio, zdim=None ) :
+    '''Rotate the Repere: Change vector componantes from
+    stretched coordinates grid --> geographic grid
+
+    uo : velocity along i at the U grid point
+    vo : valocity along j at the V grid point
     
-    u_e = lbc (u_e, nperio=nperio, cd_type=cd_type, psgn= 1.0)
-    v_n = lbc (v_n, nperio=nperio, cd_type=cd_type, psgn= 1.0)
-    
-    return u_e, v_n
-
-def rot_uv2en ( uo, vo, gsint, gcost, nperio, zdim='deptht' ) :
-    '''
-    ** Purpose :   Rotate the Repere: Change vector componantes from
-    stretched coordinates grid --> geographic grid
-    uo is on the U grid point, vo is on the V grid point
-    east-north components on the T grid point   
-    '''
-    mmath = __mmath__ (uo)
-
-    ut = U2T (uo, nperio=nperio, psgn=-1.0, zdim=zdim)
-    vt = V2T (vo, nperio=nperio, psgn=-1.0, zdim=zdim)
-    
+    Returns east-north components on the T grid point
+    '''
+    ut = u2t (uo, nperio=nperio, psgn=-1.0, zdim=zdim)
+    vt = v2t (vo, nperio=nperio, psgn=-1.0, zdim=zdim)
+
     u_e = + ut * gcost - vt * gsint
     v_n = + ut * gsint + vt * gcost
@@ -1256,19 +1845,19 @@
     u_e = lbc (u_e, nperio=nperio, cd_type='T', psgn=1.0)
     v_n = lbc (v_n, nperio=nperio, cd_type='T', psgn=1.0)
+
+    return u_e, v_n
+
+def rot_uv2enf ( uo, vo, gsinf, gcosf, nperio, zdim=None ) :
+    '''Rotates the Repere: Change vector componantes from
+    stretched coordinates grid --> geographic grid
+
+    uo : velocity along i at the U grid point
+    vo : valocity along j at the V grid point
     
-    return u_e, v_n
-
-def rot_uv2enF ( uo, vo, gsinf, gcosf, nperio, zdim='deptht' ) :
-    '''
-    ** Purpose : Rotate the Repere: Change vector componantes from
-    stretched coordinates grid --> geographic grid
-    uo is on the U grid point, vo is on the V grid point
-    east-north components on the T grid point   
-    '''
-    mmath = __mmath__ (uo)
-
-    uf = U2F (uo, nperio=nperio, psgn=-1.0, zdim=zdim)
-    vf = V2F (vo, nperio=nperio, psgn=-1.0, zdim=zdim)
-    
+    Returns east-north components on the F grid point
+    '''
+    uf = u2f (uo, nperio=nperio, psgn=-1.0, zdim=zdim)
+    vf = v2f (vo, nperio=nperio, psgn=-1.0, zdim=zdim)
+
     u_e = + uf * gcosf - vf * gsinf
     v_n = + uf * gsinf + vf * gcosf
@@ -1276,207 +1865,263 @@
     u_e = lbc (u_e, nperio=nperio, cd_type='F', psgn= 1.0)
     v_n = lbc (v_n, nperio=nperio, cd_type='F', psgn= 1.0)
-    
+
     return u_e, v_n
 
-#@numba.jit(forceobj=True)
-def U2T (utab, nperio=None, psgn=-1.0, zdim='deptht', action='ave') :
-    '''Interpolate an array from U grid to T grid i-mean)'''
+def u2t (utab, nperio=None, psgn=-1.0, zdim=None, action='ave') :
+    '''Interpolates an array from U grid to T grid (i-mean)
+    '''
     mmath = __mmath__ (utab)
     utab_0 = mmath.where ( np.isnan(utab), 0., utab)
-    lperio, aperio = lbc_diag (nperio)
+    #lperio, aperio = lbc_diag (nperio)
     utab_0 = lbc_add (utab_0, nperio=nperio, cd_type='U', psgn=psgn)
-    ix, ax = __findAxis__ (utab_0, 'x')
-    iz, az = __findAxis__ (utab_0, 'z')
-    if action == 'ave'  : ttab = 0.5 *      (utab_0 + np.roll (utab_0, axis=ix, shift=1))
-    if action == 'min'  : ttab = np.minimum (utab_0 , np.roll (utab_0, axis=ix, shift=1))
-    if action == 'max'  : ttab = np.maximum (utab_0 , np.roll (utab_0, axis=ix, shift=1))
-    if action == 'mult' : ttab =             utab_0 * np.roll (utab_0, axis=ix, shift=1)
-    ttab = lbc_del (ttab, nperio=nperio, cd_type='T', psgn=psgn)
-    
+    ax, ix = __find_axis__ (utab_0, 'x')
+    az     = __find_axis__ (utab_0, 'z')[0]
+
+    if ax :
+        if action == 'ave' :
+            ttab = 0.5 *      (utab_0 + np.roll (utab_0, axis=ix, shift=1))
+        if action == 'min' :
+            ttab = np.minimum (utab_0 , np.roll (utab_0, axis=ix, shift=1))
+        if action == 'max' :
+            ttab = np.maximum (utab_0 , np.roll (utab_0, axis=ix, shift=1))
+        if action == 'mult':
+            ttab =             utab_0 * np.roll (utab_0, axis=ix, shift=1)
+        ttab = lbc_del (ttab  , nperio=nperio, cd_type='T', psgn=psgn)
+    else :
+        ttab = lbc_del (utab_0, nperio=nperio, cd_type='T', psgn=psgn)
+
     if mmath == xr :
-        if ax != None :
+        if ax :
             ttab = ttab.assign_coords({ax:np.arange (ttab.shape[ix])+1.})
-        if zdim != None and iz != None  and az != 'olevel' : 
-            ttab = ttab.rename( {az:zdim}) 
+        if zdim and az :
+            if az != zdim :
+                ttab = ttab.rename( {az:zdim})
     return ttab
 
-#@numba.jit(forceobj=True)
-def V2T (vtab, nperio=None, psgn=-1.0, zdim='deptht', action='ave') :
-    '''Interpolate an array from V grid to T grid (j-mean)'''
+def v2t (vtab, nperio=None, psgn=-1.0, zdim=None, action='ave') :
+    '''Interpolates an array from V grid to T grid (j-mean)
+    '''
     mmath = __mmath__ (vtab)
-    lperio, aperio = lbc_diag (nperio)
+    #lperio, aperio = lbc_diag (nperio)
     vtab_0 = mmath.where ( np.isnan(vtab), 0., vtab)
     vtab_0 = lbc_add (vtab_0, nperio=nperio, cd_type='V', psgn=psgn)
-    iy, ay = __findAxis__ (vtab_0, 'y')
-    iz, az = __findAxis__ (vtab_0, 'z')
-    if action == 'ave'  : ttab = 0.5 *      (vtab_0 + np.roll (vtab_0, axis=iy, shift=1))
-    if action == 'min'  : ttab = np.minimum (vtab_0 , np.roll (vtab_0, axis=iy, shift=1))
-    if action == 'max'  : ttab = np.maximum (vtab_0 , np.roll (vtab_0, axis=iy, shift=1))
-    if action == 'mult' : ttab =             vtab_0 * np.roll (vtab_0, axis=iy, shift=1)
-    ttab = lbc_del (ttab, nperio=nperio, cd_type='T', psgn=psgn)
+    ay, jy = __find_axis__ (vtab_0, 'y')
+    az     = __find_axis__ (vtab_0, 'z')[0]
+    if ay :
+        if action == 'ave'  :
+            ttab = 0.5 *      (vtab_0 + np.roll (vtab_0, axis=jy, shift=1))
+        if action == 'min'  :
+            ttab = np.minimum (vtab_0 , np.roll (vtab_0, axis=jy, shift=1))
+        if action == 'max'  :
+            ttab = np.maximum (vtab_0 , np.roll (vtab_0, axis=jy, shift=1))
+        if action == 'mult' :
+            ttab =             vtab_0 * np.roll (vtab_0, axis=jy, shift=1)
+        ttab = lbc_del (ttab  , nperio=nperio, cd_type='T', psgn=psgn)
+    else :
+        ttab = lbc_del (vtab_0, nperio=nperio, cd_type='T', psgn=psgn)
+
     if mmath == xr :
-        if ay !=None : 
-            ttab = ttab.assign_coords({ay:np.arange(ttab.shape[iy])+1.})
-        if zdim != None and iz != None  and az != 'olevel' :
-            ttab = ttab.rename( {az:zdim}) 
+        if ay :
+            ttab = ttab.assign_coords({ay:np.arange(ttab.shape[jy])+1.})
+        if zdim and az :
+            if az != zdim :
+                ttab = ttab.rename( {az:zdim})
     return ttab
 
-#@numba.jit(forceobj=True)
-def F2T (ftab, nperio=None, psgn=1.0, zdim='depthf', action='ave') :
-    '''Interpolate an array from F grid to T grid (i- and j- means)'''
+def f2t (ftab, nperio=None, psgn=1.0, zdim=None, action='ave') :
+    '''Interpolates an array from F grid to T grid (i- and j- means)
+    '''
     mmath = __mmath__ (ftab)
     ftab_0 = mmath.where ( np.isnan(ftab), 0., ftab)
     ftab_0 = lbc_add (ftab_0 , nperio=nperio, cd_type='F', psgn=psgn)
-    ttab = V2T(F2V(ftab_0, nperio=nperio, psgn=psgn, zdim=zdim, action=action), nperio=nperio, psgn=psgn, zdim=zdim, action=action)
+    ttab = v2t (f2v (ftab_0, nperio=nperio, psgn=psgn, zdim=zdim, action=action),
+                     nperio=nperio, psgn=psgn, zdim=zdim, action=action)
     return lbc_del (ttab, nperio=nperio, cd_type='T', psgn=psgn)
 
-#@numba.jit(forceobj=True)
-def T2U (ttab, nperio=None, psgn=1.0, zdim='depthu', action='ave') :
-    '''Interpolate an array from T grid to U grid (i-mean)'''
+def t2u (ttab, nperio=None, psgn=1.0, zdim=None, action='ave') :
+    '''Interpolates an array from T grid to U grid (i-mean)
+    '''
     mmath = __mmath__ (ttab)
     ttab_0 = mmath.where ( np.isnan(ttab), 0., ttab)
     ttab_0 = lbc_add (ttab_0 , nperio=nperio, cd_type='T', psgn=psgn)
-    ix, ax = __findAxis__ (ttab_0, 'x')
-    iz, az = __findAxis__ (ttab_0, 'z')
-    if action == 'ave'  : utab = 0.5 *      (ttab_0 + np.roll (ttab_0, axis=ix, shift=-1))
-    if action == 'min'  : utab = np.minimum (ttab_0 , np.roll (ttab_0, axis=ix, shift=-1))
-    if action == 'max'  : utab = np.maximum (ttab_0 , np.roll (ttab_0, axis=ix, shift=-1))
-    if action == 'mult' : utab =             ttab_0 * np.roll (ttab_0, axis=ix, shift=-1)
-    utab = lbc_del (utab, nperio=nperio, cd_type='U', psgn=psgn)
-
-    if mmath == xr :    
-        if ax != None : 
+    ax, ix = __find_axis__ (ttab_0, 'x')[0]
+    az     = __find_axis__ (ttab_0, 'z')
+    if ix :
+        if action == 'ave'  :
+            utab = 0.5 *      (ttab_0 + np.roll (ttab_0, axis=ix, shift=-1))
+        if action == 'min'  :
+            utab = np.minimum (ttab_0 , np.roll (ttab_0, axis=ix, shift=-1))
+        if action == 'max'  :
+            utab = np.maximum (ttab_0 , np.roll (ttab_0, axis=ix, shift=-1))
+        if action == 'mult' :
+            utab =             ttab_0 * np.roll (ttab_0, axis=ix, shift=-1)
+        utab = lbc_del (utab  , nperio=nperio, cd_type='U', psgn=psgn)
+    else :
+        utab = lbc_del (ttab_0, nperio=nperio, cd_type='U', psgn=psgn)
+
+    if mmath == xr :
+        if ax :
             utab = ttab.assign_coords({ax:np.arange(utab.shape[ix])+1.})
-        if zdim != None  and iz != None  and az != 'olevel' :
-            utab = utab.rename( {az:zdim}) 
+        if zdim and az :
+            if az != zdim :
+                utab = utab.rename( {az:zdim})
     return utab
 
-#@numba.jit(forceobj=True)
-def T2V (ttab, nperio=None, psgn=1.0, zdim='depthv', action='ave') :
-    '''Interpolate an array from T grid to V grid (j-mean)'''
+def t2v (ttab, nperio=None, psgn=1.0, zdim=None, action='ave') :
+    '''Interpolates an array from T grid to V grid (j-mean)
+    '''
     mmath = __mmath__ (ttab)
     ttab_0 = mmath.where ( np.isnan(ttab), 0., ttab)
     ttab_0 = lbc_add (ttab_0 , nperio=nperio, cd_type='T', psgn=psgn)
-    iy, ay = __findAxis__ (ttab_0, 'y')
-    iz, az = __findAxis__ (ttab_0, 'z')
-    if action == 'ave'  : vtab = 0.5 *      (ttab_0 + np.roll (ttab_0, axis=iy, shift=-1))
-    if action == 'min'  : vtab = np.minimum (ttab_0 , np.roll (ttab_0, axis=iy, shift=-1))
-    if action == 'max'  : vtab = np.maximum (ttab_0 , np.roll (ttab_0, axis=iy, shift=-1))
-    if action == 'mult' : vtab =             ttab_0 * np.roll (ttab_0, axis=iy, shift=-1)
-
-    vtab = lbc_del (vtab, nperio=nperio, cd_type='V', psgn=psgn)
+    ay, jy = __find_axis__ (ttab_0, 'y')
+    az     = __find_axis__ (ttab_0, 'z')[0]
+    if jy :
+        if action == 'ave'  :
+            vtab = 0.5 *      (ttab_0 + np.roll (ttab_0, axis=jy, shift=-1))
+        if action == 'min'  :
+            vtab = np.minimum (ttab_0 , np.roll (ttab_0, axis=jy, shift=-1))
+        if action == 'max'  :
+            vtab = np.maximum (ttab_0 , np.roll (ttab_0, axis=jy, shift=-1))
+        if action == 'mult' :
+            vtab =             ttab_0 * np.roll (ttab_0, axis=jy, shift=-1)
+        vtab = lbc_del (vtab  , nperio=nperio, cd_type='V', psgn=psgn)
+    else :
+        vtab = lbc_del (ttab_0, nperio=nperio, cd_type='V', psgn=psgn)
+
     if mmath == xr :
-        if ay != None : 
-            vtab = vtab.assign_coords({ay:np.arange(vtab.shape[iy])+1.})
-        if zdim != None  and iz != None and az != 'olevel' :
-            vtab = vtab.rename( {az:zdim}) 
+        if ay :
+            vtab = vtab.assign_coords({ay:np.arange(vtab.shape[jy])+1.})
+        if zdim and az :
+            if az != zdim :
+                vtab = vtab.rename( {az:zdim})
     return vtab
 
-#@numba.jit(forceobj=True)
-def V2F (vtab, nperio=None, psgn=-1.0, zdim='depthf', action='ave') :
-    '''Interpolate an array from V grid to F grid (i-mean)'''
+def v2f (vtab, nperio=None, psgn=-1.0, zdim=None, action='ave') :
+    '''Interpolates an array from V grid to F grid (i-mean)
+    '''
     mmath = __mmath__ (vtab)
     vtab_0 = mmath.where ( np.isnan(vtab), 0., vtab)
     vtab_0 = lbc_add (vtab_0 , nperio=nperio, cd_type='V', psgn=psgn)
-    ix, ax = __findAxis__ (vtab_0, 'x')
-    iz, az = __findAxis__ (vtab_0, 'z')
-    if action == 'ave'  : 0.5 *      (vtab_0 + np.roll (vtab_0, axis=ix, shift=-1))
-    if action == 'min'  : np.minimum (vtab_0 , np.roll (vtab_0, axis=ix, shift=-1))
-    if action == 'max'  : np.maximum (vtab_0 , np.roll (vtab_0, axis=ix, shift=-1))
-    if action == 'mult' :             vtab_0 * np.roll (vtab_0, axis=ix, shift=-1)
-    ftab = lbc_del (ftab, nperio=nperio, cd_type='F', psgn=psgn)
-    
+    ax, ix = __find_axis__ (vtab_0, 'x')
+    az     = __find_axis__ (vtab_0, 'z')[0]
+    if ix :
+        if action == 'ave'  :
+            ftab = 0.5 *      (vtab_0 + np.roll (vtab_0, axis=ix, shift=-1))
+        if action == 'min'  :
+            ftab = np.minimum (vtab_0 , np.roll (vtab_0, axis=ix, shift=-1))
+        if action == 'max'  :
+            ftab = np.maximum (vtab_0 , np.roll (vtab_0, axis=ix, shift=-1))
+        if action == 'mult' :
+            ftab =             vtab_0 * np.roll (vtab_0, axis=ix, shift=-1)
+        ftab = lbc_del (ftab  , nperio=nperio, cd_type='F', psgn=psgn)
+    else :
+        ftab = lbc_del (vtab_0, nperio=nperio, cd_type='F', psgn=psgn)
+
     if mmath == xr :
-        if ax != None : 
+        if ax :
             ftab = ftab.assign_coords({ax:np.arange(ftab.shape[ix])+1.})
-        if zdim != None and iz != None and az != 'olevel' :
-            ftab = ftab.rename( {az:zdim}) 
+        if zdim and az :
+            if az != zdim :
+                ftab = ftab.rename( {az:zdim})
     return lbc_del (ftab, nperio=nperio, cd_type='F', psgn=psgn)
 
-#@numba.jit(forceobj=True)
-def U2F (utab, nperio=None, psgn=-1.0, zdim='depthf', action='ave') :
-    '''Interpolate an array from U grid to F grid i-mean)'''
+def u2f (utab, nperio=None, psgn=-1.0, zdim=None, action='ave') :
+    '''Interpolates an array from U grid to F grid i-mean)
+    '''
     mmath = __mmath__ (utab)
     utab_0 = mmath.where ( np.isnan(utab), 0., utab)
     utab_0 = lbc_add (utab_0 , nperio=nperio, cd_type='U', psgn=psgn)
-    iy, ay = __findAxis__ (utab_0, 'y')
-    iz, az = __findAxis__ (utab_0, 'z')
-    if action == 'ave'  :    ftab = 0.5 *      (utab_0 + np.roll (utab_0, axis=iy, shift=-1))
-    if action == 'min'  :    ftab = np.minimum (utab_0 , np.roll (utab_0, axis=iy, shift=-1))
-    if action == 'max'  :    ftab = np.maximum (utab_0 , np.roll (utab_0, axis=iy, shift=-1))
-    if action == 'mult' :    ftab =             utab_0 * np.roll (utab_0, axis=iy, shift=-1)
-    ftab = lbc_del (ftab, nperio=nperio, cd_type='F', psgn=psgn)
+    ay, jy = __find_axis__ (utab_0, 'y')
+    az     = __find_axis__ (utab_0, 'z')[0]
+    if jy :
+        if action == 'ave'  :
+            ftab = 0.5 *      (utab_0 + np.roll (utab_0, axis=jy, shift=-1))
+        if action == 'min'  :
+            ftab = np.minimum (utab_0 , np.roll (utab_0, axis=jy, shift=-1))
+        if action == 'max'  :
+            ftab = np.maximum (utab_0 , np.roll (utab_0, axis=jy, shift=-1))
+        if action == 'mult' :
+            ftab =             utab_0 * np.roll (utab_0, axis=jy, shift=-1)
+        ftab = lbc_del (ftab, nperio=nperio, cd_type='F', psgn=psgn)
+    else :
+        ftab = lbc_del (utab_0, nperio=nperio, cd_type='F', psgn=psgn)
 
     if mmath == xr :
-        if ay != None : 
-            ftab = ftab.assign_coords({'y':np.arange(ftab.shape[iy])+1.})
-        if zdim != None and iz != None and az != 'olevel' :
-            ftab = ftab.rename( {az:zdim}) 
+        if ay :
+            ftab = ftab.assign_coords({'y':np.arange(ftab.shape[jy])+1.})
+        if zdim and az :
+            if az != zdim :
+                ftab = ftab.rename( {az:zdim})
     return ftab
 
-#@numba.jit(forceobj=True)
-def F2T (ftab, nperio=None, psgn=1.0, zdim='deptht', action='ave') :
-    '''Interpolate an array on F grid to T grid (i- and j- means)'''
-    mmath = __mmath__ (ftab)
-    ftab_0 = mmath.where ( np.isnan(ttab), 0., ttab)
-    ftab_0 = lbc_add (ftab_0 , nperio=nperio, cd_type='F', psgn=psgn)
-    ttab = U2T(F2U(ftab_0, nperio=nperio, psgn=psgn, zdim=zdim, action=action), nperio=nperio, psgn=psgn, zdim=zdim, action=action)
-    return lbc_del (ttab, nperio=nperio, cd_type='T', psgn=psgn)
-
-#@numba.jit(forceobj=True)
-def T2F (ttab, nperio=None, psgn=1.0, zdim='deptht', action='mean') :
-    '''Interpolate an array on T grid to F grid (i- and j- means)'''
+def t2f (ttab, nperio=None, psgn=1.0, zdim=None, action='mean') :
+    '''Interpolates an array on T grid to F grid (i- and j- means)
+    '''
     mmath = __mmath__ (ttab)
     ttab_0 = mmath.where ( np.isnan(ttab), 0., ttab)
     ttab_0 = lbc_add (ttab_0 , nperio=nperio, cd_type='T', psgn=psgn)
-    ftab = T2U(U2F(ttab, nperio=nperio, psgn=psgn, zdim=zdim, action=action), nperio=nperio, psgn=psgn, zdim=zdim, action=action)
-    
+    ftab = t2u (u2f (ttab, nperio=nperio, psgn=psgn, zdim=zdim, action=action),
+                     nperio=nperio, psgn=psgn, zdim=zdim, action=action)
+
     return lbc_del (ftab, nperio=nperio, cd_type='F', psgn=psgn)
 
-#@numba.jit(forceobj=True)
-def F2U (ftab, nperio=None, psgn=1.0, zdim='depthu', action='ave') :
-    '''Interpolate an array on F grid to FUgrid (i-mean)'''
+def f2u (ftab, nperio=None, psgn=1.0, zdim=None, action='ave') :
+    '''Interpolates an array on F grid to U grid (j-mean)
+    '''
     mmath = __mmath__ (ftab)
     ftab_0 = mmath.where ( np.isnan(ftab), 0., ftab)
     ftab_0 = lbc_add (ftab_0 , nperio=nperio, cd_type='F', psgn=psgn)
-    iy, ay = __findAxis__ (ftab_0, 'y')
-    iz, az = __findAxis__ (ftab_0, 'z')
-    if action == 'ave'  : utab = 0.5 *      (ftab_0 + np.roll (ftab_0, axis=iy, shift=-1))
-    if action == 'min'  : utab = np.minimum (ftab_0 , np.roll (ftab_0, axis=iy, shift=-1))
-    if action == 'max'  : utab = np.maximum (ftab_0 , np.roll (ftab_0, axis=iy, shift=-1))
-    if action == 'mult' : utab =             ftab_0 * np.roll (ftab_0, axis=iy, shift=-1)
-
-    utab = lbc_del (utab, nperio=nperio, cd_type='U', psgn=psgn)
-    
+    ay, jy = __find_axis__ (ftab_0, 'y')
+    az     = __find_axis__ (ftab_0, 'z')[0]
+    if jy :
+        if action == 'ave'  :
+            utab = 0.5 *      (ftab_0 + np.roll (ftab_0, axis=jy, shift=-1))
+        if action == 'min'  :
+            utab = np.minimum (ftab_0 , np.roll (ftab_0, axis=jy, shift=-1))
+        if action == 'max'  :
+            utab = np.maximum (ftab_0 , np.roll (ftab_0, axis=jy, shift=-1))
+        if action == 'mult' :
+            utab =             ftab_0 * np.roll (ftab_0, axis=jy, shift=-1)
+        utab = lbc_del (utab  , nperio=nperio, cd_type='U', psgn=psgn)
+    else :
+        utab = lbc_del (ftab_0, nperio=nperio, cd_type='U', psgn=psgn)
+
     if mmath == xr :
-        utab = utab.assign_coords({ay:np.arange(ftab.shape[iy])+1.})
-        if zdim != None and iz != None and az != 'olevel' :
-            utab = utab.rename( {az:zdim}) 
+        utab = utab.assign_coords({ay:np.arange(ftab.shape[jy])+1.})
+        if zdim and az and az != zdim :
+            utab = utab.rename( {az:zdim})
     return utab
 
-#@numba.jit(forceobj=True)
-def F2V (ftab, nperio=None, psgn=1.0, zdim='depthv', action='ave') :
-    '''Interpolate an array from F grid to V grid (i-mean)'''
+def f2v (ftab, nperio=None, psgn=1.0, zdim=None, action='ave') :
+    '''Interpolates an array from F grid to V grid (i-mean)
+    '''
     mmath = __mmath__ (ftab)
     ftab_0 = mmath.where ( np.isnan(ftab), 0., ftab)
     ftab_0 = lbc_add (ftab_0 , nperio=nperio, cd_type='F', psgn=psgn)
-    ix, ax = __findAxis__ (ftab_0, 'x')
-    iz, az = __findAxis__ (ftab_0, 'z')
-    if action == 'ave'  : vtab = 0.5 *      (ftab_0 + np.roll (ftab_0, axis=ix, shift=-1))
-    if action == 'min'  : vtab = np.minimum (ftab_0 , np.roll (ftab_0, axis=ix, shift=-1))
-    if action == 'max'  : vtab = np.maximum (ftab_0 , np.roll (ftab_0, axis=ix, shift=-1))
-    if action == 'mult' : vtab =             ftab_0 * np.roll (ftab_0, axis=ix, shift=-1)
-
-    vtab = lbc_del (vtab, nperio=nperio, cd_type='V', psgn=psgn)
+    ax, ix = __find_axis__ (ftab_0, 'x')
+    az     = __find_axis__ (ftab_0, 'z')[0]
+    if ix :
+        if action == 'ave'  :
+            vtab = 0.5 *      (ftab_0 + np.roll (ftab_0, axis=ix, shift=-1))
+        if action == 'min'  :
+            vtab = np.minimum (ftab_0 , np.roll (ftab_0, axis=ix, shift=-1))
+        if action == 'max'  :
+            vtab = np.maximum (ftab_0 , np.roll (ftab_0, axis=ix, shift=-1))
+        if action == 'mult' :
+            vtab =             ftab_0 * np.roll (ftab_0, axis=ix, shift=-1)
+        vtab = lbc_del (vtab  , nperio=nperio, cd_type='V', psgn=psgn)
+    else :
+        vtab = lbc_del (ftab_0, nperio=nperio, cd_type='V', psgn=psgn)
+
     if mmath == xr :
         vtab = vtab.assign_coords({ax:np.arange(ftab.shape[ix])+1.})
-        if zdim != None and iz != None and az != 'olevel' :
-            vtab = vtab.rename( {az:zdim}) 
+        if zdim and az :
+            if az != zdim :
+                vtab = vtab.rename( {az:zdim})
     return vtab
 
-#@numba.jit(forceobj=True)
-def W2T (wtab, zcoord=None, zdim='deptht', sval=np.nan) :
-    '''
-    Interpolate an array on W grid to T grid (k-mean)
+def w2t (wtab, zcoord=None, zdim=None, sval=np.nan) :
+    '''Interpolates an array on W grid to T grid (k-mean)
+
     sval is the bottom value
     '''
@@ -1484,14 +2129,18 @@
     wtab_0 = mmath.where ( np.isnan(wtab), 0., wtab)
 
-    iz, az = __findAxis__ (wtab_0, 'z')
-       
-    ttab = 0.5 * ( wtab_0 + np.roll (wtab_0, axis=iz, shift=-1) )
-    
+    az, kz = __find_axis__ (wtab_0, 'z')
+
+    if kz :
+        ttab = 0.5 * ( wtab_0 + np.roll (wtab_0, axis=kz, shift=-1) )
+    else :
+        ttab = wtab_0
+
     if mmath == xr :
-        ttab[{az:iz}] = sval
-        if zdim != None and iz != None and az != 'olevel' :
-            ttab = ttab.rename ( {az:zdim} )
-        try    : ttab = ttab.assign_coords ( {zdim:zcoord} )
-        except : pass
+        ttab[{az:kz}] = sval
+        if zdim and az :
+            if az != zdim :
+                ttab = ttab.rename ( {az:zdim} )
+        if zcoord is not None :
+            ttab = ttab.assign_coords ( {zdim:zcoord} )
     else :
         ttab[..., -1, :, :] = sval
@@ -1499,7 +2148,7 @@
     return ttab
 
-#@numba.jit(forceobj=True)
-def T2W (ttab, zcoord=None, zdim='depthw', sval=np.nan, extrap_surf=False) :
-    '''Interpolate an array from T grid to W grid (k-mean)
+def t2w (ttab, zcoord=None, zdim=None, sval=np.nan, extrap_surf=False) :
+    '''Interpolates an array from T grid to W grid (k-mean)
+
     sval is the surface value
     if extrap_surf==True, surface value is taken from 1st level value.
@@ -1507,50 +2156,55 @@
     mmath = __mmath__ (ttab)
     ttab_0 = mmath.where ( np.isnan(ttab), 0., ttab)
-    iz, az = __findAxis__ (ttab_0, 'z')
-    wtab = 0.5 * ( ttab_0 + np.roll (ttab_0, axis=iz, shift=1) )
+    az, kz = __find_axis__ (ttab_0, 'z')
+    wtab = 0.5 * ( ttab_0 + np.roll (ttab_0, axis=kz, shift=1) )
 
     if mmath == xr :
-        if extrap_surf : wtab[{az:0}] = ttabb[{az:0}]
-        else           : wtab[{az:0}] = sval
-    else : 
-        if extrap_surf : wtab[..., 0, :, :] = ttab[..., 0, :, :]
-        else           : wtab[..., 0, :, :] = sval
+        if extrap_surf :
+            wtab[{az:0}] = ttab[{az:0}]
+        else           :
+            wtab[{az:0}] = sval
+    else :
+        if extrap_surf :
+            wtab[..., 0, :, :] = ttab[..., 0, :, :]
+        else           :
+            wtab[..., 0, :, :] = sval
 
     if mmath == xr :
-        if zdim != None and iz != None and az != 'olevel' :
-                wtab = wtab.rename ( {az:zdim})
-        if zcoord != None : wtab = wtab.assign_coords ( {zdim:zcoord})
-        else              : ztab = wtab.assign_coords ( {zdim:np.arange(ttab.shape[iz])+1.} )
+        if zdim and az and az != zdim :
+            wtab = wtab.rename ( {az:zdim})
+        if zcoord is not None :
+            wtab = wtab.assign_coords ( {zdim:zcoord})
+        else :
+            wtab = wtab.assign_coords ( {zdim:np.arange(ttab.shape[kz])+1.} )
     return wtab
 
-#@numba.jit(forceobj=True)
-def fill (ptab, nperio, cd_type='T', npass=1, sval=0.) :
-    '''
-    Fill sval values with mean of neighbours
-   
+def fill (ptab, nperio, cd_type='T', npass=1, sval=np.nan) :
+    '''Fills np.nan values with mean of neighbours
+
     Inputs :
        ptab : input field to fill
        nperio, cd_type : periodicity characteristics
-    '''       
+    '''
 
     mmath = __mmath__ (ptab)
 
-    DoPerio = False ; lperio = nperio
+    do_perio  = False
+    lperio    = nperio
     if nperio == 4.2 :
-        DoPerio = True ; lperio = 4
+        do_perio, lperio = True, 4
     if nperio == 6.2 :
-        DoPerio = True ; lperio = 6
-        
-    if DoPerio :
-        ztab = lbc_add (ptab, nperio=nperio, sval=sval)
-    else : 
+        do_perio, lperio = True, 6
+
+    if do_perio :
+        ztab = lbc_add (ptab, nperio=nperio)
+    else :
         ztab = ptab
-        
-    if np.isnan (sval) : 
+
+    if np.isnan (sval) :
         ztab   = mmath.where (np.isnan(ztab), np.nan, ztab)
     else :
         ztab   = mmath.where (ztab==sval    , np.nan, ztab)
-   
-    for nn in np.arange (npass) : 
+
+    for _ in np.arange (npass) :
         zmask = mmath.where ( np.isnan(ztab), 0., 1.   )
         ztab0 = mmath.where ( np.isnan(ztab), 0., ztab )
@@ -1576,16 +2230,16 @@
         zcount = lbc (zcount, nperio=lperio, cd_type=cd_type)
         znew   = lbc (znew  , nperio=lperio, cd_type=cd_type)
-        
+
         ztab = mmath.where (np.logical_and (zmask==0., zcount>0), znew/zcount, ztab)
 
     ztab = mmath.where (zcount==0, sval, ztab)
-    if DoPerio : ztab = lbc_del (ztab, nperio=lperio)
+    if do_perio :
+        ztab = lbc_del (ztab, nperio=lperio)
 
     return ztab
 
-#@numba.jit(forceobj=True)
 def correct_uv (u, v, lat) :
     '''
-    Correct a Cartopy bug in Orthographic projection
+    Corrects a Cartopy bug in orthographic projection
 
     See https://github.com/SciTools/cartopy/issues/1179
